import 'package:imi/src/data/network/response/course_detail_response.dart';
import 'package:imi/src/utils/enum.dart';

///
/// Code generated by jsonToDartModel https://ashamp.github.io/jsonToDartModel/
///
class Items {
  Course? course;
  Event? event;
  UserInformation? userInformation;
  String? productType;
  int? discount;
  int? id;
  int? price;
  String? note;
  int? quantity;
  List<int>? validCouponIds;

  Items(
      {this.course,
        this.event,
        this.userInformation,
        this.productType,
        this.discount,
        this.id,
        this.price,
        this.note,
        this.quantity,
        this.validCouponIds});

  Items.fromJson(Map<String, dynamic> json) {
    course =
    json['course'] != null ? new Course.fromJson(json['course']) : null;
    event = json['event'] != null ? new Event.fromJson(json['event']) : null;
    userInformation = json['userInformation'] != null
        ? new UserInformation.fromJson(json['userInformation'])
        : null;
    productType = json['productType'];
    discount = json['discount'];
    id = json['id'];
    price = json['price'];
    note = json['note'];
    quantity = json['quantity'];
    if (json['validCouponIds'] != null) {
      final v = json['validCouponIds'];
      final arr0 = <int>[];
      v.forEach((v) {
        arr0.add(v.toInt());
      });
      validCouponIds = arr0;
    }
  }


  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.course != null) {
      data['course'] = this.course!.toJson();
    }
    if (this.event != null) {
      data['event'] = this.event!.toJson();
    }
    if (this.userInformation != null) {
      data['userInformation'] = this.userInformation!.toJson();
    }
    data['productType'] = this.productType;
    data['discount'] = this.discount;
    data['id'] = this.id;
    data['price'] = this.price;
    data['note'] = this.note;
    data['quantity'] = this.quantity;
    data['validCouponIds'] = this.validCouponIds;
    if (validCouponIds != null) {
      final v = validCouponIds;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v);
      });
      data['validCouponIds'] = arr0;
    }
    return data;
  }
}

class CouponLevels {
/*
{
  "id": 1,
  "name": "string",
  "status": "string"
}
*/

  int? id;
  String? name;
  String? status;

  CouponLevels({
    this.id,
    this.name,
    this.status,
  });
  CouponLevels.fromJson(Map<String, dynamic> json) {
    id = json['id']?.toInt();
    name = json['name']?.toString();
    status = json['status']?.toString();
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['id'] = id;
    data['name'] = name;
    data['status'] = status;
    return data;
  }
}

class MyOrderCoupons {
/*
{
  "code": "string",
  "compile": true,
  "createdDate": 1,
  "description": "string",
  "discount": 1,
  "discountType": "string",
  "expiredDate": 1,
  "id": 1,
  "levels": [
    {
      "id": 1,
      "name": "string",
      "status": "string"
    }
  ],
  "maxQuantity": 1,
  "minPrice": 1,
  "modifiedDate": 1,
  "status": "string",
  "type": "string"
}
*/

  String? code;
  bool? compile;
  int? createdDate;
  String? description;
  int? discount;
  String? discountType;
  int? expiredDate;
  int? id;
  List<CouponLevels>? levels;
  int? maxQuantity;
  int? minPrice;
  int? modifiedDate;
  String? status;
  String? type;

  MyOrderCoupons({
    this.code,
    this.compile,
    this.createdDate,
    this.description,
    this.discount,
    this.discountType,
    this.expiredDate,
    this.id,
    this.levels,
    this.maxQuantity,
    this.minPrice,
    this.modifiedDate,
    this.status,
    this.type,
  });
  MyOrderCoupons.fromJson(Map<String, dynamic> json) {
    code = json['code']?.toString();
    compile = json['compile'];
    createdDate = json['createdDate']?.toInt();
    description = json['description']?.toString();
    discount = json['discount']?.toInt();
    discountType = json['discountType']?.toString();
    expiredDate = json['expiredDate']?.toInt();
    id = json['id']?.toInt();
    if (json['levels'] != null) {
      final v = json['levels'];
      final arr0 = <CouponLevels>[];
      v.forEach((v) {
        arr0.add(CouponLevels.fromJson(v));
      });
      levels = arr0;
    }
    maxQuantity = json['maxQuantity']?.toInt();
    minPrice = json['minPrice']?.toInt();
    modifiedDate = json['modifiedDate']?.toInt();
    status = json['status']?.toString();
    type = json['type']?.toString();
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['code'] = code;
    data['compile'] = compile;
    data['createdDate'] = createdDate;
    data['description'] = description;
    data['discount'] = discount;
    data['discountType'] = discountType;
    data['expiredDate'] = expiredDate;
    data['id'] = id;
    if (levels != null) {
      final v = levels;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v.toJson());
      });
      data['levels'] = arr0;
    }
    data['maxQuantity'] = maxQuantity;
    data['minPrice'] = minPrice;
    data['modifiedDate'] = modifiedDate;
    data['status'] = status;
    data['type'] = type;
    return data;
  }
}

class Coupons {
/*
{
  "coupon": {
    "code": "string",
    "compile": true,
    "createdDate": 1,
    "description": "string",
    "discount": 1,
    "discountType": "string",
    "expiredDate": 1,
    "id": 1,
    "levels": [
      {
        "id": 1,
        "name": "string",
        "status": "string"
      }
    ],
    "maxQuantity": 1,
    "minPrice": 1,
    "modifiedDate": 1,
    "status": "string",
    "type": "string"
  },
  "isValid": true
}
*/

  MyOrderCoupons? coupon;
  bool? isValid;

  Coupons({
    this.coupon,
    this.isValid,
  });
  Coupons.fromJson(Map<String, dynamic> json) {
    coupon = (json['coupon'] != null)
        ? MyOrderCoupons.fromJson(json['coupon'])
        : null;
    isValid = json['isValid'];
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (coupon != null) {
      data['coupon'] = coupon!.toJson();
    }
    data['isValid'] = isValid;
    return data;
  }
}

class Course {
  String? avatarUrl;
  String? code;
  int? currentFee;
  String? description;
  int? id;
  bool? isHot;
  String? name;
  int? preferentialFee;
  int? priority;
  int? startDate;
  String? status;
  String? studyForm;
  String? studyTime;
  String? teacher;
  List<Testimonials>? testimonials;
  double? vat;

  Course(
      {this.avatarUrl,
        this.code,
        this.currentFee,
        this.description,
        this.id,
        this.isHot,
        this.name,
        this.preferentialFee,
        this.priority,
        this.startDate,
        this.status,
        this.studyForm,
        this.studyTime,
        this.teacher,
        this.testimonials,
        this.vat});

  Course.fromJson(Map<String, dynamic> json) {
    avatarUrl = json['avatarUrl'];
    code = json['code'];
    currentFee = json['currentFee'];
    description = json['description'];
    id = json['id'];
    isHot = json['isHot'];
    name = json['name'];
    preferentialFee = json['preferentialFee'];
    priority = json['priority'];
    startDate = json['startDate'];
    status = json['status'];
    studyForm = json['studyForm'];
    studyTime = json['studyTime'];
    teacher = json['teacher'];
    if (json['testimonials'] != null) {
      testimonials = <Testimonials>[];
      json['testimonials'].forEach((v) {
        testimonials!.add(new Testimonials.fromJson(v));
      });
    }
    vat = json['vat'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['avatarUrl'] = this.avatarUrl;
    data['code'] = this.code;
    data['currentFee'] = this.currentFee;
    data['description'] = this.description;
    data['id'] = this.id;
    data['isHot'] = this.isHot;
    data['name'] = this.name;
    data['preferentialFee'] = this.preferentialFee;
    data['priority'] = this.priority;
    data['startDate'] = this.startDate;
    data['status'] = this.status;
    data['studyForm'] = this.studyForm;
    data['studyTime'] = this.studyTime;
    data['teacher'] = this.teacher;
    if (this.testimonials != null) {
      data['testimonials'] = this.testimonials!.map((v) => v.toJson()).toList();
    }
    data['vat'] = this.vat;
    return data;
  }
}

class Event {
  String? address;
  String? avatarUrl;
  String? code;
  int? currentFee;
  String? description;
  int? endDate;
  int? id;
  bool? isHot;
  String? name;
  int? preferentialFee;
  int? priority;
  int? productId;
  int? startDate;
  String? status;
  String? studyTime;
  String? teacher;

  Event(
      {this.address,
        this.avatarUrl,
        this.code,
        this.currentFee,
        this.description,
        this.endDate,
        this.id,
        this.isHot,
        this.name,
        this.preferentialFee,
        this.priority,
        this.productId,
        this.startDate,
        this.status,
        this.studyTime,
        this.teacher});

  Event.fromJson(Map<String, dynamic> json) {
    address = json['address'];
    avatarUrl = json['avatarUrl'];
    code = json['code'];
    currentFee = json['currentFee'];
    description = json['description'];
    endDate = json['endDate'];
    id = json['id'];
    isHot = json['isHot'];
    name = json['name'];
    preferentialFee = json['preferentialFee'];
    priority = json['priority'];
    productId = json['productId'];
    startDate = json['startDate'];
    status = json['status'];
    studyTime = json['studyTime'];
    teacher = json['teacher'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['address'] = this.address;
    data['avatarUrl'] = this.avatarUrl;
    data['code'] = this.code;
    data['currentFee'] = this.currentFee;
    data['description'] = this.description;
    data['endDate'] = this.endDate;
    data['id'] = this.id;
    data['isHot'] = this.isHot;
    data['name'] = this.name;
    data['preferentialFee'] = this.preferentialFee;
    data['priority'] = this.priority;
    data['productId'] = this.productId;
    data['startDate'] = this.startDate;
    data['status'] = this.status;
    data['studyTime'] = this.studyTime;
    data['teacher'] = this.teacher;
    return data;
  }
}

class UserInformation {
  String? email;
  String? phone;
  String? userName;
  int? provinceId;

  UserInformation({this.email, this.phone, this.provinceId,this.userName});

  UserInformation.fromJson(Map<String, dynamic> json) {
    email = json['email'];
    phone = json['phone'];
    userName=json['userName'];
    provinceId = json['provinceId'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['provinceId'] = this.provinceId;
    data['userName'] = this.userName;
    return data;
  }
}

class FetchMyOrderV2 {
  List<Coupons>? coupons;
  List<Items>? items;
  int? pointExchangeRate;
  int? orderId;
  int? total;
  int? totalComboCouponDiscount;
  bool? usePoint;
  FetchMyOrderV2({this.coupons, this.items,this.pointExchangeRate, this.orderId, this.total,this.usePoint});

  FetchMyOrderV2.fromJson(Map<String, dynamic> json) {
    if (json['coupons'] != null) {
      coupons = <Coupons>[];
      json['coupons'].forEach((v) {
        coupons!.add(new Coupons.fromJson(v));
      });
    }
    if (json['items'] != null) {
      items = <Items>[];
      json['items'].forEach((v) {
        items!.add(new Items.fromJson(v));
      });
    }
    pointExchangeRate=json['pointExchangeRate'];
    orderId = json['orderId'];
    total = json['total'];
    totalComboCouponDiscount = json['totalComboCouponDiscount'];
    usePoint= json['usePoint'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.coupons != null) {
      data['coupons'] = this.coupons!.map((v) => v.toJson()).toList();
    }
    if (this.items != null) {
      data['items'] = this.items!.map((v) => v.toJson()).toList();
    }

    data['pointExchangeRate'] = this.pointExchangeRate;
    data['orderId'] = this.orderId;
    data['total'] = this.total;
    data['totalComboCouponDiscount'] = this.totalComboCouponDiscount;
    data['usePoint']=this.usePoint;
    return data;
  }
}

class DetailCartData {

  FetchMyOrderV2? fetchMyOrder;

  DetailCartData({
    this.fetchMyOrder,
  });
  DetailCartData.fromJson(Map<String, dynamic> json) {
    fetchMyOrder = (json['fetchMyOrderV2'] != null)
        ? FetchMyOrderV2.fromJson(json['fetchMyOrderV2'])
        : null;
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (fetchMyOrder != null) {
      data['fetchMyOrderV2'] = fetchMyOrder!.toJson();
    }
    return data;
  }
}

class DetailCart {
/*
{
  "data": {
    "fetchMyOrder": {
      "coupons": [
        {
          "coupon": {
            "code": "string",
            "compile": true,
            "createdDate": 1,
            "description": "string",
            "discount": 1,
            "discountType": "string",
            "expiredDate": 1,
            "id": 1,
            "levels": [
              {
                "id": 1,
                "name": "string",
                "status": "string"
              }
            ],
            "maxQuantity": 1,
            "minPrice": 1,
            "modifiedDate": 1,
            "status": "string",
            "type": "string"
          },
          "isValid": true
        }
      ],
      "items": [
        {
          "discount": null,
          "id": 11,
          "item": {
            "avatarUrl": "",
            "code": "KH_NTDD_305",
            "currentFee": 12000000,
            "description": "",
            "id": 42,
            "isHot": true,
            "name": "Khóa học làm giàu không khó trong thời đại 4.0",
            "preferentialFee": 7500000,
            "priority": 30,
            "startDate": 1654826508000,
            "status": "OPENING",
            "studyForm": "Offline",
            "studyTime": "10 buổi/5tuần",
            "teacher": "Liên Phạm Thị",
            "testimonials": [
              {
                "avatarUrl": "",
                "description": "Khóa học thực sự bổ ích, mình trau dồi được nhiều kiến thức về nghệ thuật đương đại trong thời đại mới.",
                "fullName": "Tran Hai Dang",
                "id": 62,
                "postId": null,
                "priority": 1,
                "title": "Nhân viên văn phòng"
              }
            ],
            "vat": null
          },
          "note": "string",
          "price": null,
          "quantity": 10,
          "validCouponIds": null
        }
      ],
      "total": 2
    }
  }
}
*/

  DetailCartData? data;

  DetailCart({
    this.data,
  });
  DetailCart.fromJson(Map<String, dynamic> json) {
    data =
        (json['data'] != null) ? DetailCartData.fromJson(json['data']) : null;
  }
  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (data != null) {
      data['data'] = this.data!.toJson();
    }
    return data;
  }
}
